<template>
  <div class="admin-nodecard grid gap-6 items-center p-4">
    <div class="flex items-center justify-between xs:w-full">
      <div class="flex items-center gap-4">
        <div class="flex justify-center items-center relative">
          <img width="64" height="64" src="@/assets/images/views/index/polygon.svg" />
          <img
            width="48"
            height="48"
            :src="require(`@/assets/images/coins/${nodeInfo.cryptocurrency_symbol.toLowerCase()}.svg`)"
            class="absolute inset-0 m-auto shrink-0"
          />
        </div>
        <p class="text-lg leading-5 font-bold text-txtdprim w-full overflow-hidden overflow-ellipsis whitespace-nowrap">
          {{ nodeTitle }}
        </p>
      </div>
      <div
        class="bg-btndsec h-8 px-2 flex justify-center items-center text-sm font-medium text-txtdsec rounded-12 uppercase"
      >
        {{ nodeInfo.cryptocurrency_symbol }}
      </div>
    </div>
    <div class="flex items-center gap-4 xs:hidden">
      <div style="height: 45px" class="w-0.5 bg-brdddef"></div>
      <div>
        <p class="text-sm font-medium text-txtdtert">Specification</p>
        <p class="leading-5 font-bold text-txtdprim capitalize">{{ nodeInfo.network + ', ' + nodeInfo.mode }}</p>
      </div>
    </div>
    <div class="flex items-center gap-4 xs:hidden">
      <div style="height: 45px" class="w-0.5 bg-brdddef"></div>
      <div>
        <p class="text-sm font-medium text-txtdtert">Status</p>
        <p class="leading-5 font-bold text-txtdprim capitalize">{{ nodeInfo.status }}</p>
      </div>
    </div>
    <div class="flex items-center gap-4 overflow-hidden overflow-ellipsis">
      <div style="height: 45px" class="w-0.5 bg-brdddef"></div>
      <div class="flex-1">
        <p class="text-sm font-medium text-txtdtert">Owner</p>
        <p class="leading-5 font-bold text-txtdprim capitalize w-full overflow-hidden overflow-ellipsis">
          {{ nodeInfo.public_address }}
        </p>
      </div>
    </div>
    <div class="flex items-center gap-4 overflow-hidden overflow-ellipsis">
      <div style="height: 45px" class="w-0.5 bg-brdddef"></div>
      <div class="flex-1">
        <p class="text-sm font-medium text-txtdtert">Expired</p>
        <p class="leading-5 font-bold text-txtdprim capitalize w-full overflow-hidden overflow-ellipsis">
          {{ nodeInfo.paid_until }}
        </p>
      </div>
    </div>
    <div class="ml-auto relative" v-click-outside="closeContextMenu">
      <div
        v-show="nodeInfo.isMenuOpen"
        class="absolute z-10 right-16 -top-8 border border-brdddef px-6 pb-4 gap-4 rounded-16 bg-bgdsec"
      >
        <p
          v-for="status in projectStatuses"
          :key="status.key"
          class="text-txtdprim hover:text-blue font-medium cursor-pointer mt-4"
          @click="updateStatus(status)"
        >
          {{ status.title }}
        </p>
        <div class="my-2 h-px bg-brdddef"></div>
        <p class="text-txtdprim hover:text-blue font-medium cursor-pointer mt-2" @click="deleteProject">Delete</p>
      </div>
      <UiButton buttonHeight="sm" colorType="secondary" class="w-12 rounded-12 xs:w-full" @click="$emit('toggle-menu')">
        <img width="24" height="24" src="@/assets/images/admin/dots.svg" />
      </UiButton>
    </div>
  </div>
</template>

<script>
import { manageProject, deleteProject } from '@/api/admin';

import currencies from '@/utils/currencies';
import UiButton from '@/components/ui/UiButton.vue';

export default {
  name: 'AdminNodeCard',

  components: { UiButton },

  props: {
    nodeInfo: {
      type: Object,
      default: () => ({}),
    },
  },

  data() {
    return {
      projectStatuses: [
        {
          title: 'Pending',
          key: 'pending',
        },
        {
          title: 'Deploying',
          key: 'deploying',
        },
        {
          title: 'Active',
          key: 'active',
        },
        {
          title: 'Expired',
          key: 'expired',
        },
      ],
    };
  },

  computed: {
    nodeTitle() {
      const currency = currencies.find((coin) => coin.symbol === this.nodeInfo.cryptocurrency_symbol);
      if (currency) return currency.full_name;
      else return 'Bitcoin';
    },
  },

  methods: {
    closeContextMenu() {
      this.$emit('close-menu');
    },

    async updateStatus(status) {
      this.$store.commit('setAdminLoading', true);
      try {
        this.closeContextMenu();
        try {
          await manageProject(this.nodeInfo.node_id, { set_status: status.key });
        } catch (err) {
          console.error(err);
        }
        this.$emit('update-projects');
        this.$store.dispatch('setPopupDisplay', {
          display: true,
          text: 'Project status successfully updated.',
        });
      } catch (err) {
        console.error(err);
        this.$store.dispatch('setPopupDisplay', {
          display: true,
          text: 'Error while updating status.',
          status: 'error',
        });
      }
    },

    async deleteProject() {
      this.$store.commit('setAdminLoading', true);
      try {
        this.closeContextMenu();
        await deleteProject(this.nodeInfo.node_id);
        this.$store.dispatch('setPopupDisplay', {
          display: true,
          text: 'Project successfully deleted.',
        });
        this.$emit('update-projects');
      } catch (err) {
        console.error(err);
        this.$store.dispatch('setPopupDisplay', {
          display: true,
          text: 'Error while deleting project.',
          status: 'error',
        });
      } finally {
        this.$store.commit('setAdminLoading', false);
      }
    },
  },
};
</script>

<style lang="scss" scoped>
.admin-nodecard {
  grid-template-columns: 220px 150px 100px max-content 200px 1fr;
}
</style>
